/* eslint-disable no-console */
import { storiesOf } from '@storybook/react';
import readme from './README.md';
import { action } from '@storybook/addon-actions';
import { withKnobs, text } from '@storybook/addon-knobs';
import { withReadme } from 'storybook-readme';
var readmeURL = 'https://bit.ly/2Z9PGsC';

var props = function props() {
  return {
    default: function _default() {
      return {
        onClick: action('onClick'),
        onFocus: action('onFocus'),
        className: text('class name', 'some-class'),
        iconName: text('icon name', 'Add16'),
        description: text('description', 'description')
      };
    }
  };
};

storiesOf('Card', module).addDecorator(withKnobs).add('card', withReadme(readme, function () {
  return require('./stories/default').default(props());
}), {
  info: {
    /* eslint-disable no-useless-escape */
    text: "\n        Cards provide an at-a glance preview of the content they link to and frequently contain\n        easily-consumable content. The example below shows an empty card. Create Card Content, Card Footer,\n        Card Status and Card Actions components to add content to your card.\n          You can find more detailed information surrounding usage of this component\n          at the following url: ".concat(readmeURL, "\n        ")
    /* eslint-enable no-useless-escape */

  }
});